import{s as Ut,n as Dt,o as Jt}from"../chunks/scheduler.9039eef2.js";import{S as Kt,i as Ot,g as o,s as i,r as ht,A as Vt,h as s,f as n,c as a,j as Ft,u as ft,x as r,k as Qt,y as Xt,a as l,v as ct,d as vt,t as gt,w as xt}from"../chunks/index.cdcc3d35.js";import{H as yt}from"../chunks/Heading.96ce3702.js";function Yt(Lt){let p,W,B,S,m,R,u,Ct="How fast is Llama on Inferentia2?  Let’s figure out!",G,d,_t="For this benchmark we will use the LLama 2 7B and 13B models with different configurations:",N,h,Tt="<thead><tr><th>Model type</th> <th>num cores</th> <th>batch_size</th></tr></thead> <tbody><tr><td>Llama2 7B - L (latency)</td> <td>24</td> <td>1</td></tr> <tr><td>Llama2 7B - T (throughput)</td> <td>24</td> <td>4</td></tr> <tr><td>Llama2 13B - L (latency)</td> <td>24</td> <td>1</td></tr> <tr><td>Llama2 13B - T (throughput)</td> <td>24</td> <td>4</td></tr></tbody>",F,f,$t="<em>Note: all models are compiled with a maximum sequence length of 2048.</em>",Q,c,wt="All models are compiled to use the full extent of cores available on the <code>inf2.48xlarge</code> instance.",U,v,bt='<em>Note: please refer to the <a href="https://aws.amazon.com/ec2/instance-types/inf2/" rel="nofollow">inferentia2 product page</a> for details on the available instances.</em>',D,g,Ht="We created two “latency” oriented configurations for the <code>llama2 7B</code> and <code>llama2 13B</code> models that can serve only one request at a time, but at full speed and two “throughput” oriented configurations to serve up to four requests in parallel.",J,x,Mt=`To evaluate the models, we generate tokens up to a total sequence length of 1024, starting from
256 input tokens (i.e. we generate 256, 512 and 768 tokens).`,K,y,O,L,Pt=`The encoding time or time to first token is the time required to process the input tokens and generate the first output token.
It is a very important metric, as it corresponds to the latency directly perceived by the user when streaming generated tokens.`,V,C,kt=`We test the encoding time for increasing context sizes, 256 input tokens corresponding roughly to a typical Q/A usage,
while 768 is more typical of a Retrieval Augmented Generation (RAG) use-case.`,X,_,zt="Encoding time is expressed in <strong>seconds</strong>.",Y,T,At='<img src="https://raw.githubusercontent.com/huggingface/optimum-neuron/main/docs/assets/benchmarks/inferentia-llama2/encoding_times.png" alt="Llama2 inferentia2 encoding-time" title="Encoding time"/>',Z,$,Et="We can see that all deployed models exhibit excellent response times, even for long contexts.",tt,w,et,b,qt="The end-to-end latency corresponds to the total time to reach a sequence length of 1024 tokens.",nt,H,jt="It therefore includes the encoding and generation time.",lt,M,Bt="Latency is expressed in <strong>seconds</strong>.",it,P,It='<img src="https://raw.githubusercontent.com/huggingface/optimum-neuron/main/docs/assets/benchmarks/inferentia-llama2/latencies.png" alt="Llama2 inferentia2 end-to-end latency" title="Latency"/>',at,k,Wt="All models deployed on the high-end instance exhibit a good latency, even those actually configured to optimize throughput.",ot,z,st,A,St=`We adopt the same convention as other benchmarks to evaluate the throughput, by dividing the end-to-end
latency by the sum of both input and output tokens.
In other words, we divide the end-to-end latency by <code>batch_size * sequence_length</code> to obtain the number of generated tokens per second.`,rt,E,Rt="Throughput is expressed in <strong>tokens/second</strong>.",pt,q,Gt='<img src="https://raw.githubusercontent.com/huggingface/optimum-neuron/main/docs/assets/benchmarks/inferentia-llama2/throughputs.png" alt="Llama2 inferentia2 throughput" title="Throughput"/>',mt,j,Nt="Again, the models deployed on the high-end instance have a very good throughput, even those optimized for latency.",ut,I,dt;return m=new yt({props:{title:"Llama performance on AWS Inferentia2 (Latency & Througput)",local:"llama-performance-on-aws-inferentia2-latency--througput",headingTag:"h1"}}),y=new yt({props:{title:"Encoding time (time to first token)",local:"encoding-time-time-to-first-token",headingTag:"h2"}}),w=new yt({props:{title:"End-to-end Latency",local:"end-to-end-latency",headingTag:"h2"}}),z=new yt({props:{title:"Throughput",local:"throughput",headingTag:"h3"}}),{c(){p=o("meta"),W=i(),B=o("p"),S=i(),ht(m.$$.fragment),R=i(),u=o("p"),u.textContent=Ct,G=i(),d=o("p"),d.textContent=_t,N=i(),h=o("table"),h.innerHTML=Tt,F=i(),f=o("p"),f.innerHTML=$t,Q=i(),c=o("p"),c.innerHTML=wt,U=i(),v=o("p"),v.innerHTML=bt,D=i(),g=o("p"),g.innerHTML=Ht,J=i(),x=o("p"),x.textContent=Mt,K=i(),ht(y.$$.fragment),O=i(),L=o("p"),L.textContent=Pt,V=i(),C=o("p"),C.textContent=kt,X=i(),_=o("p"),_.innerHTML=zt,Y=i(),T=o("p"),T.innerHTML=At,Z=i(),$=o("p"),$.textContent=Et,tt=i(),ht(w.$$.fragment),et=i(),b=o("p"),b.textContent=qt,nt=i(),H=o("p"),H.textContent=jt,lt=i(),M=o("p"),M.innerHTML=Bt,it=i(),P=o("p"),P.innerHTML=It,at=i(),k=o("p"),k.textContent=Wt,ot=i(),ht(z.$$.fragment),st=i(),A=o("p"),A.innerHTML=St,rt=i(),E=o("p"),E.innerHTML=Rt,pt=i(),q=o("p"),q.innerHTML=Gt,mt=i(),j=o("p"),j.textContent=Nt,ut=i(),I=o("p"),this.h()},l(t){const e=Vt("svelte-u9bgzb",document.head);p=s(e,"META",{name:!0,content:!0}),e.forEach(n),W=a(t),B=s(t,"P",{}),Ft(B).forEach(n),S=a(t),ft(m.$$.fragment,t),R=a(t),u=s(t,"P",{"data-svelte-h":!0}),r(u)!=="svelte-97vj14"&&(u.textContent=Ct),G=a(t),d=s(t,"P",{"data-svelte-h":!0}),r(d)!=="svelte-xsrahx"&&(d.textContent=_t),N=a(t),h=s(t,"TABLE",{"data-svelte-h":!0}),r(h)!=="svelte-16reyeh"&&(h.innerHTML=Tt),F=a(t),f=s(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-kzjexk"&&(f.innerHTML=$t),Q=a(t),c=s(t,"P",{"data-svelte-h":!0}),r(c)!=="svelte-24jj9y"&&(c.innerHTML=wt),U=a(t),v=s(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1zgafe"&&(v.innerHTML=bt),D=a(t),g=s(t,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1sn2idj"&&(g.innerHTML=Ht),J=a(t),x=s(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-qvcal6"&&(x.textContent=Mt),K=a(t),ft(y.$$.fragment,t),O=a(t),L=s(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-r7j18k"&&(L.textContent=Pt),V=a(t),C=s(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1i4byqo"&&(C.textContent=kt),X=a(t),_=s(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-10ey5lc"&&(_.innerHTML=zt),Y=a(t),T=s(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-11xayf9"&&(T.innerHTML=At),Z=a(t),$=s(t,"P",{"data-svelte-h":!0}),r($)!=="svelte-10ycv4g"&&($.textContent=Et),tt=a(t),ft(w.$$.fragment,t),et=a(t),b=s(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1fyy0ax"&&(b.textContent=qt),nt=a(t),H=s(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-hxg66a"&&(H.textContent=jt),lt=a(t),M=s(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-p58dz0"&&(M.innerHTML=Bt),it=a(t),P=s(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1tni7uj"&&(P.innerHTML=It),at=a(t),k=s(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-14wgz6z"&&(k.textContent=Wt),ot=a(t),ft(z.$$.fragment,t),st=a(t),A=s(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1be56jh"&&(A.innerHTML=St),rt=a(t),E=s(t,"P",{"data-svelte-h":!0}),r(E)!=="svelte-14m9i5e"&&(E.innerHTML=Rt),pt=a(t),q=s(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-i7or77"&&(q.innerHTML=Gt),mt=a(t),j=s(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1ksw41h"&&(j.textContent=Nt),ut=a(t),I=s(t,"P",{}),Ft(I).forEach(n),this.h()},h(){Qt(p,"name","hf:doc:metadata"),Qt(p,"content",Zt)},m(t,e){Xt(document.head,p),l(t,W,e),l(t,B,e),l(t,S,e),ct(m,t,e),l(t,R,e),l(t,u,e),l(t,G,e),l(t,d,e),l(t,N,e),l(t,h,e),l(t,F,e),l(t,f,e),l(t,Q,e),l(t,c,e),l(t,U,e),l(t,v,e),l(t,D,e),l(t,g,e),l(t,J,e),l(t,x,e),l(t,K,e),ct(y,t,e),l(t,O,e),l(t,L,e),l(t,V,e),l(t,C,e),l(t,X,e),l(t,_,e),l(t,Y,e),l(t,T,e),l(t,Z,e),l(t,$,e),l(t,tt,e),ct(w,t,e),l(t,et,e),l(t,b,e),l(t,nt,e),l(t,H,e),l(t,lt,e),l(t,M,e),l(t,it,e),l(t,P,e),l(t,at,e),l(t,k,e),l(t,ot,e),ct(z,t,e),l(t,st,e),l(t,A,e),l(t,rt,e),l(t,E,e),l(t,pt,e),l(t,q,e),l(t,mt,e),l(t,j,e),l(t,ut,e),l(t,I,e),dt=!0},p:Dt,i(t){dt||(vt(m.$$.fragment,t),vt(y.$$.fragment,t),vt(w.$$.fragment,t),vt(z.$$.fragment,t),dt=!0)},o(t){gt(m.$$.fragment,t),gt(y.$$.fragment,t),gt(w.$$.fragment,t),gt(z.$$.fragment,t),dt=!1},d(t){t&&(n(W),n(B),n(S),n(R),n(u),n(G),n(d),n(N),n(h),n(F),n(f),n(Q),n(c),n(U),n(v),n(D),n(g),n(J),n(x),n(K),n(O),n(L),n(V),n(C),n(X),n(_),n(Y),n(T),n(Z),n($),n(tt),n(et),n(b),n(nt),n(H),n(lt),n(M),n(it),n(P),n(at),n(k),n(ot),n(st),n(A),n(rt),n(E),n(pt),n(q),n(mt),n(j),n(ut),n(I)),n(p),xt(m,t),xt(y,t),xt(w,t),xt(z,t)}}}const Zt='{"title":"Llama performance on AWS Inferentia2 (Latency & Througput)","local":"llama-performance-on-aws-inferentia2-latency--througput","sections":[{"title":"Encoding time (time to first token)","local":"encoding-time-time-to-first-token","sections":[],"depth":2},{"title":"End-to-end Latency","local":"end-to-end-latency","sections":[{"title":"Throughput","local":"throughput","sections":[],"depth":3}],"depth":2}],"depth":1}';function te(Lt){return Jt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ie extends Kt{constructor(p){super(),Ot(this,p,te,Yt,Ut,{})}}export{ie as component};
